/*
  Name: CMPgame.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This is for the client part of multiplayer games
*/

#ifndef MP_GAME_CLIENT
#define MP_GAME_CLIENT

#include <libnet.h>
#include <string>

#include "packet.h"
#include "messageClass.h"
#include "mpcUnit.h"
#include "mpRequest.h"

class clientMultiplayerGame
{
private:
	//Graphics
	BITMAP *lifeBar, *armorBar;
	BITMAP *weaponSprites[WEAPONTYPES - 2];
	
	//The connection
	NET_CONN *serverConn;
	//A messageclass instance and a boolean to tell wether to destroy the
	//messageClass in the destructor (false for server)
	messageClass *messages;
	bool destroyMessageClass;
	bool connected;
	int waitingForConnection;
	int messageNeededCountdown;
	packet pack;
	bool exit;
	int myID;
	int maxPlayers;
	mpcUnit *players;
	mapClass map;
	
	int curWeapon;
	
	BITMAP **sprites;

	void sendExitPacket();
	char gameType;
	void loadMap();
	//Players life and armor
	int maxArmor, armor;
	int maxLife, life;
	int getArmorPercentage();
	int getLifePercentage();
	void showStatistics();
public:
	clientMultiplayerGame(std::string name);
	~clientMultiplayerGame();
	int operator()();
	void setMessageClass(messageClass *msc);
	void exeLogic();
	void exeGraphic();
	bool checkConnection();
	//WFC == waitingForConnection
	int getWFC();
	bool wantsExit();
	inline int getmyID() { return myID; }
};

#endif
