/*
  Name: ElementaryFunctions.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: Some basic functions that are used in almost any other file
*/

#ifndef HEADER_ELEMENTARY
#define HEADER_ELEMENTARY

#include <allegro.h>
#include <string>

extern const int TIMER_FPS;
extern const double PI;
extern const unsigned char
MAJOR_VERSION,
MINOR_VERSION,
VERSION_LETTER;
extern const char DELIMITER;
extern const string VERSIONSTRING;
extern volatile int	timerCounter;
//extern const int screenW, screenH;

void show(bool showMouse = false, BITMAP *bitmap = NULL);
BITMAP *loadBitmap(std::string filename);
BITMAP *createBitmap(int width, int height);
BITMAP *createDatafileBitmap(DATAFILE *datafile, int index);
void setMode(int &mode);
void setMode(char &mode);

inline char *i2ch(int &i) { return (char*)(&i); }
inline char *b2ch(bool &b) { return (char*)(&b); }
inline char *f2ch(float &f) { return (char*)(&f); }
inline double deg2rad(int deg) { return double(deg) * PI / 128.0; }
inline int rad2deg(double rad) { return int(rad * 128.0 / PI); }

//Compile a script and store it in the scripts/temp.mss file
void compileExtern(std::string scriptpath);

//Get string to file
bool fileSelect(std::string message, std::string &path, std::string ext, int w, int h);

//Create a new map from the scriptfile specified
void newMap(std::string mappath);

//Pause the game for a specific amount of time
inline void pause(int ticks)
{
	while(timerCounter < ticks);
	timerCounter = 0;
}

//Test if a given file exists
bool fileExists(std::string filename);

//Get string version of a number
std::string i2str(int i, int minLength = 0);

//Get string of a savegame path with the specified number
std::string getSavegamePath(int n);

//Weapons are: pistol, shotgun, MG, sniper, grenade, rocket launcher, grenade splint, rocket splint
const int WEAPONTYPES = 8;
//Speed of the Weapon
extern const float SPEED[WEAPONTYPES];
//Damage the weapon causes
extern const int DAMAGE[WEAPONTYPES];
//Armor pierced (0 = none, 1 = pierces light, 2 = pierces heavy)
extern const int PIERCE[WEAPONTYPES];
//Time it needs until you can fire again
extern const int RATE[WEAPONTYPES];
//Bullets that are fired with each shot
extern const int BULLETS[WEAPONTYPES];
//Angle that is added/substracted from the unit's angle
extern const int SPREAD[WEAPONTYPES];
//Range after which the bullet expires
extern const int RANGE[WEAPONTYPES];
//Splints are produced after each SPLINTS degree
extern const int SPLINTS[WEAPONTYPES];
//After how many shots do the AI people have to wait
//extern const int AIWAIT[4];

//The real distance that bullets can travel ingame
extern int realRange[WEAPONTYPES];

#endif
