/*
  Name: Entity.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: The entity class is the parent class of all Objects visible ingame
*/

#ifndef ENTITY_CLASS
#define ENTITY_CLASS

#include <allegro.h>

//The maximum of sprites that can be used
const int MAXSPRITES = 6;

enum states
{
	STATE_STAND,
	STATE_WEAPON,
	STATE_SHOOT,
	STATE_WALK,
	STATE_WALKSHOOT,
	STATE_DEAD,
};

enum AISTATES
{
	STATE_STANDBY,
	STATE_PATROL,
	STATE_ATTACK,
	STATE_FOLLOW,
};

class Entity
{
protected:
	//Position on the map
	float posX, posY;
	//The direction the Entity is facing
	int direction;
	//The current status
	int curState;
	//The radius, used for collision detection
	int radius;
	//The stati for AI
	int AIstate;
public:
	Entity();
	~Entity();

	//Draw the entity on the screen
	//virtual void draw(int cameraX, int cameraY);

	int getRadius();
	int &getState();
	int &getAIState();
	int &getDirection();
	int getPosX();
	int getPosY();
	float &getFlPosX();
	float &getFlPosY();
};

#endif
