/*
  Name: Errors.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This file contains the functions of the errors namespace,
	  that will show error messages for all kind of errors
*/

#ifndef HEADER_ERRORS
#define HEADER_ERRORS

#include <string>

namespace errors
{
	//Error function that can be used for virtually everything
	void fatalError(std::string message);

	//If Timer wasn't initialised
	void timerError();

	//If there's no keyboard driver
	void keyboardError();

	//No sounddriver found
	void soundDriverError();

	//If no graphicmode could be entered
	void graphicModeError();

	//create_bitmap failed
	void createError();

	//load_bitmap failed
	void loadBitError(std::string name);

	//load_datafile failed
	void datafileError(std::string name);

	//loading a sound file failed
	void sampleLoadError(std::string sampleName);

	//Division by 0
	void divBy0Error(std::string module);

	//Loading the map failed
	void mapLoadError(std::string mapName, std::string reason);

	//Loading a tilemap failed
	void tilesetLoadError(std::string mapName, std::string reason);

	//Error inside a script
	void scriptError(std::string reason);

	//Error in map Editor
	void editorError(std::string reason);
	
	//Error in network code
	void networkError(std::string reason);
	
	//Error in multiplayer mode
	void multiplayerError(std::string description);
	
	//Error in mouse initialisation
	void mouseError();
}

#endif
