/*
  Name: SPgame.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: The game class is the most important class,
    It contains all other classes needed in game and
	makes communication between different classes possible
*/

#ifndef GAME_CLASS
#define GAME_CLASS

#include <allegro.h>
#include <string>
#include "SPmapClass.h"
#include "playerUnit.h"
#include "bytecode.h"
#include "Unit.h"
#include "VM.h"
#include "messageClass.h"
#include "bullet.h"
#include "requests.h"

class singlePlayerGame
{
private:
	SPmapClass map;
	playerUnit player;
	bytecode dieCode;
	int enemyTypes;
	Unit *enemyBasetype;
	int civilianTypes;
	Unit *civilianBasetype;

	BITMAP *lifeBar, *armorBar;
	BITMAP *dirArrow;

	//The mission description is stored on this picture
	BITMAP *missionDesc;

	VirtualMachine VM;

	messageClass *messages;

	BITMAP *weaponSprites[WEAPONTYPES - 2];

	int objectives;
	int *objectivePosXs,
		*objectivePosYs;

	//Contains all civilians and enemies
	int nUnit;
	Unit **units;
	bytecode **onKill;
	bytecode **onCall;
	bool *origCode;

	bytecode *globalScript;

	bullet *bullets;

	void addBullets(bulletRequest *bReq);
	void explosion(bulletRequest bReq);
	void handleMoveRequest(moveRequest *mReq, VirtualMachine &VM, int type, void *bulletTeam = 0, int bulletDirection = 0);
	bool collides(int left1, int top1, int right1, int bottom1, int left2, int top2, int right2, int bottom2);

	void showMissionDescription(std::string name, bool campaign = false);
	void reviewMissionDescription();

	//These values can be seen as equivalents to the difficulty
	//They are added to the HEALREFILLS and AMMOREFILLS values
	int healRefillPlus, ammoRefillPlus;

	//Some consts for the showMissionDescription function
	const int maxSizeX, maxSizeY;
	int objectiveHeight;

	//Some cheat variables
	int godCheat;
public:
	singlePlayerGame(std::string mapPath, int healRefills, int ammoRefills);
	int operator()(std::string &returnValue);
	~singlePlayerGame();
};

#endif
