/*
  Name: Sound.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This class provides a high level API for
	  loading and playing sounds of different formats
*/


#ifndef SOUND_CLASS
#define SOUND_CLASS

#include <allegro.h>
#include <almp3.h>
#include <string>

class Sound
{
private:
	int active;

	bool soundEffect;

	SAMPLE *sample;
	MIDI *midi;
	ALMP3_MP3 *mp3;
	char *mp3Data;

	int loop;
	int vol;
	int pan;
	int freq;

	bool autoPoll;
public:
	Sound();
	Sound(std::string filename, bool doPoll = false);
	~Sound();
	void load(std::string filename, bool doPoll = false);
	void play(int loop, int vol = 0, int pan = 127, int freq = 1000);
	void stop();
	void destroy();
	int isActive();
	void poll();
	void musicUpdate();
};

#endif
