/*
  Name: bytecode.h
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This class contains byte code for a single event
    It can be fed into the virtual machine
*/

#ifndef MSS_BYTECODE
#define MSS_BYTECODE

#include <string>

class bytecode
{
private:
	unsigned char *data;
	int length;
	int pos;
public:
	//The constructor for pre-extracted code is not needed
	//bytecode(char *code);
	bytecode();
	//Constructor for full code. The constructor will extract the code of the specified event
	bytecode(unsigned char *fullCode, int event);
	//Same function as the constructor above
	void extract(unsigned char *fullCode, int event);
	//Returns true if data is actually stored in data
	int getLength();

	//Constructor that will copy all data from the given bytecode
	void operator=(bytecode &code);


	//Sets pos to 0
	void reset();
	//Read data
	void read(unsigned char *dest, int bytes);
	void read(char *dest, int bytes);

	//Returns position in code
	int getPos();

	//Reads a byte and determines if the next parameter is a variable
	bool isVar();

	//Reads 4 bytes and returns the value
	int getConstPar();

	//Reads 1 byte and returns the value
	int getVarPar();

	//Returns a string containing all characters that were found before limiter
	std::string getString(char limiter);

	~bytecode();
};

#endif
