/*
  Name: packet.cpp
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: This class is used to send and receive packets
*/

#include <libnet.h>
#include <allegro.h>

#include "packet.h"

packet::packet()
{
	buffer = new char[512];
	bufSize = 512;
	pos = 0;
}

packet::~packet()
{
	if(buffer)
		delete [] buffer;
}

void packet::write(const char *data, const int length)
{
	int i;
	for(i = 0; i < length; ++i)
	    buffer[pos++] = data[i];
}

void packet::send(NET_CONN *connection)
{
	if(pos)
		net_send_rdm(connection, buffer, pos);
}

int packet::receive(NET_CONN *connection)
{
	if(connection && net_query_rdm(connection))
	{
		reset();
	    return net_receive_rdm(connection, buffer, bufSize);
	}
	return 0;
}

void packet::read(char *data, const int length)
{
	int i;
	for(i = 0; i < length; ++i)
	    data[i] = buffer[pos++];
}

void packet::reset()
{
	pos = 0;
}

void packet::put(const char toPut)
{
	buffer[pos++] = toPut;
}

char packet::get() { return buffer[pos++]; }
