/*
  Name: requests.cpp
  Copyright: Polecatsoft 2005
  Game: Mercenary Soldier
  Author: Master Lenman
  Date: -
  Description: All kinds of requests that are handed from Entities to the map
*/

#include "requests.h"

void moveRequest::set(float oPosX, float oPosY, float nPosX, float nPosY, int scripts, int rights, int rad)
{
	oldPosX = oPosX;
	oldPosY = oPosY;
	newPosX = nPosX;
	newPosY = nPosY;
	fScripts = scripts;
	fRights = rights;
	radius = rad;
	requested = true;
	declined = false;
}

void moveRequest::set(float oPosX, float oPosY, float nPosX, float nPosY, int scripts, int rights, int rad, bool req)
{
	requested = req;
	set(oPosX, oPosY, nPosX, nPosY, scripts, rights, rad);
}

void moveRequest::decline()
{
	newPosX = oldPosX;
	newPosY = oldPosY;
	declined = true;
}

void moveRequest::declineX()
{
	declined = true;
	newPosX = oldPosX;
}

void moveRequest::declineY()
{
	declined = true;
	newPosY = oldPosY;
}

float moveRequest::getOldPosX()
{
	return oldPosX;
}

float moveRequest::getOldPosY()
{
	return oldPosY;
}

float moveRequest::getNewPosX()
{
	return newPosX;
}

float moveRequest::getNewPosY()
{
	return newPosY;
}

int moveRequest::getScripts()
{
	return fScripts;
}

int moveRequest::getRights()
{
	return fRights;
}

int moveRequest::getRadius()
{
	return radius;
}

bool moveRequest::wasRequested()
{
	return requested;
}

bool moveRequest::wasDeclined()
{
	return declined;
}

bulletRequest::bulletRequest()
{
	posX = 0.0;
	posY = 0.0;
	dir = 0;
	weaponType = 0;
	creator = 0;
}

void bulletRequest::set(float pX, float pY, int direction, int type, void *iTeam)
{
	posX = pX;
	posY = pY;
	dir = direction;
	weaponType = type;
	creator = iTeam;
}
float bulletRequest::getPosX()
{
	return posX;
}
float bulletRequest::getPosY()
{
	return posY;
}
int bulletRequest::getDir()
{
	return dir;
}
int bulletRequest::getType()
{
	return weaponType;
}
void *bulletRequest::getTeam()
{
	return creator;
}
